#lang racket

;; A status is either 'error, 'failure, or 'success,
;; where 'error and 'failure both count as failure,
;; but only 'error counts as an error.

(provide (all-defined-out))

;; #f -> error, #t -> success
(define (boolean->status v)
  (if v
      'success
      'error))

(define (status-failure? s)
  (or (eq? s 'error) (eq? s 'failure)))

(define (status-error? s)
  (eq? s 'error))

(define failure-status 'failure)
